'Asset Tracker by Charles Dietz
                                                   
'ver 0.1.0, 06-13-2005                                                             
'ver 0.2.0  06-23-2005
' - added password (master password: John 14:6)                                
'ver 0.3.0  06-28-2005                                                              
' - streamlined code, minor password corrections                              
' - added $fileVer for opening data file
'ver 0.4.0  07-06-2005
' - added commas to record values
' - added current values to list of accounts
' - added options in list of accounts for by name or by account type
' - added options in main list of records for last dates, all dates, by accts
' - added totals for account types to Summary
' - listbox liability items shown in red
'ver 0.5.0  07-13-2005
' - streamlined code by eliminating rec().acctNo
' - eliminated %ID_AddClose from add record form
' - new account inserted at position determined from acctSort()
' - corrected required IRA withdrawal (based on end of previous year)
'ver 0.5.1  07-27-2005
' - corrected several routines needing XXXITEMDATA for the acctName combobox
'   also corrected logic errors in initAcctName()
'ver 0.5.2  08-24-05
' - fixed acctName field (search for editing, and GPF problem with list)
' - corrected problem with adding account (ptr to acct not updated for rec)
' - corrected problem with adding record
' - added COMMAND$ to load file
'ver 0.5.3  11-18-05
' - show last value when adding new record
' - networth history
'ver 0.6.0  12-24-05
' - delete account plus all records
' - recent files under File menu
' - allow account deposits & withdrawals
' - distinguish accounts that can contain stock trades
' - view stock trades for an applicable account
' - add, edit, and delete stock trades
'ver 0.7.0  09-19-06
' - finished initializing data for settings routine
' - extended IRA withdrawal to cover case when Dec 31 stmts of last year are missing
'ver 0.7.1  06-22-07
' - corrected display problem after viewing or editing accounts
' - grayed file menu items, Save, SaveAs, Settings, & Print, until a file is opened
'ver 0.8.0  06-23-07
' - simplified menus to just Files, View, Help
' - used two layers for Asset records and Accounts
' - updated temp() while deleting records related to account being deleted
'ver 0.8.1  07-13-07
' - added global layerID and hLayer variables to correct account list line numbers
'ver 0.9.0  08-07-08
' - improved code, removing acctSort() in favor of keeping acct() itself ordered
' - swapped acctName and acctNo fields in acct() for sorting ease
' - added acctOpened, acctClosed, acctMature, and openValue fields to accountType
' - substituted bits in BYTE for stocks field in accountType
' - added archiving feature to keep displayed list sizes manageable
'ver 1.0.0  05-06-09, compiler 9.01
' - redefined data folder as system special folder (Documents & Settings for XP)
' - corrected use of "<" for adding multiple account numbers
'ver 1.1.0  10-12-09, compiler 9.02
' - replaced ISFILE(dataFolder) with folderExists()... compiler 9.02 changed
' - corrected list of recent files in Files menu
'ver 1.2.0  01-12-2010, compiler 9.03
' - add double entry to record dates (see convertDate())
' - minor editing and navigation corrections
'ver 1.2.1  05-17-2010, compiler 9.04
' - fixed bug in Required IRA withdrawal (div by 100000 because of double entry dates)
'ver 1.2.2  05-24-2010, compiler 9.04
' - changed data storage from _DOCUMENTS to _APPDATA
'ver 1.2.3  10-05-2010
' - corrected problems with IRA withdrawal
' - eliminated need for withdrawDate variables
'ver 1.2.4  10-28-2010
' - improved statusbar text related to archived accounts
' - corrected problems with adding stock trade
'ver 1.2.5  11-03-2011
' - show only existing files at bottom of file menu
'ver 1.2.6  07-25-2014 (last version with data update)
' - corrected initAcctNo() for archived accounts 
' - improved editing of rec() items with addRecord
'ver 1.30  07-25-2014 (version without data update)
' - removed all references to oldAccountType, oldAssetType
'ver 1.31  01-19-2015
' - tie age with owner using acct().reserved for yr,mo (3410)
' - corrected record value to allow for zero input                     
' - initialized value of nAcctName for adding new record
'ver 1.32  08-17-2015
' - corrected bug associated with drop-down acctNo when first acctName (index = 0)
' - corrected bug with dataFiles() 4 line list under File menu
'ver 1.33  10-09-2015
' - corrected duplicate files from 4 most recent files saved (File menu)
' - corrected wrong archived account value (used wrong double entry value)
' - corrected wrong insertion points in byDate() and byAcct() when adding record
' - corrected file data holding birthdays
' - correction to delete entry from moreData() when deleting acct
' - other minor bugs corrected
'ver 1.34  11-13-2015
' - corrected byDate() and byAcct() sort by update to ver 1.34 on opening
' - corrected problem with selecting record when jumping from accounts to records
' - added aTypes of 'stocks/bonds' and 'deposit box'
' - networth now calculated as assets - liabilities (positive liability values)
' - improved printing to correspond with rec() and acct() listings
' - added printAcctDefn routine to printing the ith account definition
' - improved settings routine (added reset button for tracking date)
' - improved code relating to acctTye() allowing for unused ones (can add later)
' - display my own help files which are created by noteKeeper
'ver 1.35  12-18-2015
' - corrected showCurrentAcctValue routine for all type acctNo's
' - added 'wait' to mousePtr when saving file                                   
' - corrected problem of disk/network disconnect during open and save
' - enable menus (as well as buttons) after first acct is defined
' - corrected 'View data' (wasn't showing all the data)
'ver 1.36  04-30-2016 
' - saveAs, prompt to override if selected file already exists
'ver 1.37  10-08-2016
' - moved Settings from File to View Menu
' - dataFolder defaults to curDir if asset.ini and asset.hlp exists there
' - corrected order of 4 files written to iniFile (saved file must be first)
'ver 1.38  10-22-2017
' - INCLUDE appHelp, my own generated help file
' - removed closed from View menu but added View all accts (which includes closed ones)
' - improved getNetworth(yr), and used it in networthHist()
' - corrected totals() in Sub Summary so not to relect closed accounts 
'ver 1.40  05-21-2018 
' - added data search when viewing all accounts (especially useful with moreData)
' - corrected error removing password (bad error with STRPTR arg going out of scope)
' - corrected problem when adding record yielding wrong account number
' - improved code for adding record when leaving date or acctName field
' - improved editing record allowing deposits and withdrawals
'-----------------------------------------------------------------------------------------
                          
'Main dialog box
%ID_RecList      = 101
%ID_hdr1         = 102
%ID_hdr2         = 103
%ID_hdr3         = 104
%ID_hdr4         = 105
%ID_AddRec       = 106                                                                                              
%ID_DelRec       = 107
%ID_EditRec      = 108
'%ID_Back         = 109
%ID_Records      = 110
%ID_Accounts     = 111
%ID_Stocks       = 112
%ID_LastDates    = 113
%ID_AllDates     = 114
%ID_ByAccts      = 115

%ID_AcctList     = 121
%ID_hdr11        = 122
%ID_hdr12        = 123
%ID_hdr13        = 124
%ID_hdr14        = 125
%ID_hdr15        = 126
%ID_hdr16        = 127  
%ID_AddAcct      = 130
%ID_DelAcct      = 131
%ID_EditAcct     = 132
%ID_Hist         = 133
%ID_AcctData     = 134
%ID_AcctSrch     = 135
%ID_FindNext     = 136
%ID_FindPrev     = 137
%ID_Records1     = 141
%ID_Accounts1    = 142
%ID_Stocks1      = 143
%ID_AcctsByName  = 144
%ID_AcctsByType  = 145
%ID_AcctsAll     = 146
%ID_Statusbar    = 147

'Record form
%ID_Date         = 201
%ID_Today        = 202
%ID_EndYr        = 203
%ID_Value        = 204
'%ID_ViewAcct     = 205
%ID_AddRecord    = 205
%ID_AddValue     = 241
%ID_SubValue     = 242
%ID_ChgValue     = 243
%ID_Amount       = 244
%ID_Shares       = 245
%ID_numShares    = 246
%ID_price        = 247
%ID_sharePrice   = 248

'account form
%ID_AcctNo       = 301
%ID_AcctName     = 302
%ID_AcctType     = 303
%ID_AcctNameTxt  = 304
%ID_AcctTypeTxt  = 305
%ID_Owner        = 306
%ID_MoreData     = 307
%ID_OK           = 308
%ID_OpenDate     = 321
%ID_CloseDate    = 322
%ID_MatureDate   = 323
%ID_OpenValue    = 324
%ID_PrnAcctDefn  = 325

'Print dialog box
%ID_PrnAssets    = 501
%ID_InclClosed   = 502

'Summary
%ID_ShowNetworth = 601
%ID_TrackDate    = 602
%ID_Owner1       = 603
%ID_Owner2       = 604
%ID_Bday1        = 605
%ID_Bday2        = 606
%ID_OwnerIRA     = 607
%ID_AcctTotals   = 608

'Networth
%ID_NetworthHist = 701

'Settings
%ID_Password     = 801
%ID_SetPW        = 802
%ID_Confirm      = 803
%ID_TrackReset   = 804

'Menu system ---------------------
'File menu
%IDM_Open        = 901
%IDM_Save        = 902
%IDM_SaveAs      = 903
%IDM_Settings    = 904
%IDM_Print       = 905
%IDM_Exit        = 906

'View menu
%IDM_Records     = 921
%IDM_Accounts    = 922
%IDM_Closed      = 924
%IDM_Summary     = 925
%IDM_Networth    = 926

'Help menu
%IDM_Help        = 931
%IDM_About       = 932

TYPE recordType  '10 bytes used for rec() array
   date          AS DWORD        'date of record... 19341013                                
   acct          AS WORD         'index to acct()
   value         AS LONG         'reported acct value
END TYPE

TYPE accountType '81 bytes
   acctName      AS STRING *32        'account name
   acctNo        AS STRING *13        'account number
   owner         AS STRING *12        'tax payer id (social security no)
   dateOpened    AS DWORD             'opening date
   dateClosed    AS DWORD             'closing date
   dateMature    AS DWORD             'maturity date
   aType         AS BYTE              'type or acct, +/- accounts in acctType()
   unusedByte    AS BYTE              'unused byte
   openValue     AS LONG              'opening value of account
   value         AS LONG              'latest value of account
   unusedWord    AS WORD              'unused word
END TYPE

type stockType  '34 bytes
   company       as string*24    'company offering the stock
   symbol        as string*6     'stock symbol
   price         as dword        'current price of stock (an edited or found amount)
end type
              
GLOBAL hDlg AS LONG
GLOBAL hRec AS LONG
GLOBAL hAcct AS LONG
GLOBAL hRecList AS LONG
GLOBAL hAcctList AS LONG
GLOBAL hStatus AS LONG
GLOBAL hMenu AS LONG
GLOBAL hMouseMenu AS LONG
GLOBAL hMouseMenu1 AS LONG
GLOBAL hFileMenu AS LONG
GLOBAL hViewMenu AS LONG
GLOBAL hHelpMenu AS LONG
GLOBAL oldLBproc AS LONG
GLOBAL oldLBproc1 AS LONG
global lastLayerNo as long
GLOBAL recSelect AS LONG
GLOBAL acctSelect AS LONG
GLOBAL numRecs AS DWORD
GLOBAL numAccts AS DWORD
GLOBAL numAcctTypes AS DWORD
GLOBAL numTrades AS DWORD
GLOBAL numColumns AS DWORD
GLOBAL origDir AS STRING
GLOBAL acctName AS STRING
GLOBAL acctNum AS STRING
global numAssets as long
GLOBAL layerID AS LONG
GLOBAL hLayer AS LONG
GLOBAL listMode AS byte
GLOBAL recView AS integer
GLOBAL acctView AS BYTE
GLOBAL showClosed AS BYTE
GLOBAL hideNetworth AS long
GLOBAL inclClosed AS long
GLOBAL dataFolder AS STRING
GLOBAL iniFile AS STRING
GLOBAL thisFile AS STRING
GLOBAL back AS LONG
GLOBAL fileChanged AS LONG
GLOBAL taxes AS LONG
GLOBAL doNotQuit AS LONG
GLOBAL trackingDate AS DWORD
GLOBAL owner1, owner2 AS STRING
GLOBAL birthday1, birthday2 AS DWORD
GLOBAL filePW AS STRING
GLOBAL masterPW AS STRING
GLOBAL errorPW AS LONG
GLOBAL reserved1, reserved2 AS DWORD
GLOBAL acct() AS accountType  'order alphabetically
GLOBAL rec() AS recordType    'order as they occur
GLOBAL colPos() AS LONG
GLOBAL byDate() AS DWORD    'records ordered by [date + acctName + acctNo]
GLOBAL byAcct() AS DWORD    'records ordered by [acctName + acctNo + date]
GLOBAL moreData() AS STRING
GLOBAL acctType() AS STRING 
GLOBAL IRA_Table() AS SINGLE
GLOBAL dataFiles() AS STRING
GLOBAL balance() AS LONG
GLOBAL activeTrades() AS LONG
GLOBAL layer() AS LONG
global numLayerCtrls() as long
global lastFound as long
global sFind as string

DECLARE FUNCTION HtmlHelp LIB "hhctrl.ocx" ALIAS "HtmlHelpA" _
          (BYVAL LONG, ASCIIZ, BYVAL LONG, BYVAL LONG ) AS LONG
          
'Notes:
'- accounts are positioned alphabetically by 'acctName + acctNo' 

'adding stocks later on...
'- acctName = "Stock - xyz" for stock symbol xyz
'- records
'- stocks
'- accounts
   
